﻿Imports IdeaBlade.EntityModel
Imports IdeaBlade.Core


Partial Public Class Customer

    ''' <summary>
    ''' Deletes the Customer, its related orders and international orders, and their related OrderDetails
    ''' </summary>
    Public Function DeleteObjectGraph() As Integer

        Dim counter As Integer = 0

        For Each order In Me.Orders.ToList()
            For Each dtl In order.OrderDetails.ToList()
                dtl.EntityAspect.Delete()
                counter += 1
            Next dtl
            If Not order.InternationalOrder.EntityAspect.IsNullEntity Then
                order.InternationalOrder.EntityAspect.Delete()
                counter += 1
            End If
            order.EntityAspect.Delete()
            counter += 1
        Next order

        Me.EntityAspect.Delete()
        counter += 1

        Return counter
    End Function

End Class
